package mezz.jei.common.gui.recipes;

import java.util.List;

import mezz.jei.api.gui.drawable.IDrawable;
import mezz.jei.api.recipe.category.IRecipeCategory;
import mezz.jei.common.gui.textures.Textures;
import mezz.jei.common.input.IUserInputHandler;
import mezz.jei.common.util.ImmutableRect2i;
import net.minecraft.class_2561;
import net.minecraft.class_4587;

public abstract class RecipeGuiTab implements IUserInputHandler {
	public static final int TAB_HEIGHT = 24;
	public static final int TAB_WIDTH = 24;

	private final Textures textures;
	protected final int x;
	protected final int y;
	private final ImmutableRect2i area;

	public RecipeGuiTab(Textures textures, int x, int y) {
		this.textures = textures;
		this.x = x;
		this.y = y;
		this.area = new ImmutableRect2i(x, y, TAB_WIDTH, TAB_HEIGHT);
	}

	public boolean isMouseOver(double mouseX, double mouseY) {
		return area.contains(mouseX, mouseY);
	}

	public abstract boolean isSelected(IRecipeCategory<?> selectedCategory);

	public void draw(boolean selected, class_4587 poseStack, int mouseX, int mouseY) {
		IDrawable tab = selected ? textures.getTabSelected() : textures.getTabUnselected();

		tab.draw(poseStack, x, y);
	}

	public abstract List<class_2561> getTooltip();
}
